---------------------
wxWINDOWS CHANGE LIST
---------------------

Version 1.68 November 1997
--------------------------

- Fixed Motif wxFlushEvents to process non-X events (e.g. from
  CORBA).
- Fixed wx_canvs.cpp XView compilation problem.
- Fixed ntwxwin.mak for VC++ 4.2 and above.
- Added missing JPEG files in wxImage.
- Fixed wxWeb compilation for IRIX.
- Fixed wxFrame creation under Windows so frames can be
  created without a caption (bug introduced in 1.67).
- Fixed --I bug in IRIX make.env.
- Fixed bug in wxFindFirstFile (Unix).
- Fixed bug with Motif popup menus popping up in wrong place.
- Added wxFrame/wxDialog Raise and Lower functions.
- Added wxPageSetupDialog and wxPageSetupData (Page Setup
  supercedes Print Setup in Windows 95).
- Fixed Gnu-Win32 printing bug (PrintDlg fails because GnuWin32
  PRINTDLG structure is the wrong size - needs fixing properly).
- Added Set/GetOrientation to wxPrintData so orientation can be
  passed from the dialogs to the printing or previewing.
- Fixed wxinstal script which assumed archives were already
  unpacked.
- Fixed samples/makefile.unx, utils/makefile.unx and other
  makefiles.
- Added Unix wxExecute patch from Guilhem Lavaux.
- Fixed wxExecute for WIN32 synchronous operation.
- Cured double-tab problem and no autoscrolling problem in
  wxTextWindow (Windows).
- Win95 wxButtonBar::OnLeftClick now behaves as documented
  if it returns FALSE (i.e. can veto the toggle).
- Fixed wxMenu::Checked under both Windows and Motif
  to return the correct value.
- Fixed wxFileSelector on Motif to insert default path
  as required by later versions of Motif.
- Fixed wxGenericGrid - my anti-flicker fix
  caused non-refreshing under Windows.
- Motif nested popup menus fixed (undefined USE_NL_POPUP_MENU_FIX).
- Fixed bug in wxIcon destructor (Motif).

Version 1.67 July 1997
----------------------

- Test for negative width, height in DrawEllipse under X.
- Initialized buttonFont and labelFont wxbItem, to cure
  static item crash.
- Cured wxSizer problem that caused full layout sample
  to crash on window exit.
- Cured bug in Windows wxBitmap constructor where
  depth and planes arguments were reversed.
- Fixed memory leak in ODBC class wxRecordSet.
- install.exe now deletes Program Manager items before
  adding new ones.
- Fixed bug in Windows code where colourmaps weren't being
  used for drawing with pens and brushes.
- Fixed event handler-related crash in Motif when USE_GADGETS = 1.
- Added USE_IOSTREAMH to wx_setup.h, to allow for VC++ 4.2 and
  higher.
- Fixed missing backslashes in .rc files.
- Commented out an extra SetSize in wxCanvas::SetScrollBars
  (Motif) because of flickering/infinite recursion problems.
  Apps _may_ need to call SetSize to get scrollbars to show.
- Added ITA fixes for Metrowerks WIN32.
- Removed colour saving bug in Dialog Editor (green and blue
  swapped).
- Corrected a drawing bug in tabbed dialog code.
- Corrected Windows OnCharHook to get shift/ctrl state.
- Specifying default (-1) frame position and/or height now works in Windows.
- Windows/Motif wxScrollBar and canvas scrollbar code corrected.
  wxGenericGrid modified accordingly. Note that in SetScrollbars,
  page size parameters are now ignored and page
  sizes are calculated from current client window size.
- Added WS_CLIPCHILDREN style to MSW wxCanvas, to avoid flicker
  when using a canvas as a parent for other windows.
- Removed test in Motif code that didn't allow a canvas to be a child of
  a canvas.
- Changed wxFrame::SetIcon to set icon properly in Windows.
  Can now mark a Win95 executable as version 4.0 without problems
  with icons.
- Fixed wxScreenDC for X and added functionality to allow drawing on top of
  windows, instead of under windows, which is the behaviour under
  X.
- Added wxSplitterWindow class (Motif and Windows).
- Added wxGetMousePosition.
- Replaced complex, buggy double-click detection in Motif with
  simpler scheme.
- Removed dependencies in makefile.unx that caused continual
  remake on some platforms.
- Added client data argument to wxListBox::Set.
- Revised wxinstal and seperated out make.env's for different
  platforms, in src/makeenvs.
- Windows distribution now packaged with WISE Install.
- Added wxScrollBar fixes by Chris Breeze.
- Fixed flicker and scrollbar handling in wxGrid.
- Added Forty Thieves sample by Chris Breeze.
- wxUpdateIterator now uses physical (not logical) coordinates
  on all platforms, for consistency.
- Now distribute HTML as standard on Unix, in preference to
  XLP format.

Version 1.66F January 28th 1997
-------------------------------

- fixed out-by-one memcpy bug in wxSuffixMap::Initialize.
- applied Torsten Schmale's fix for Motif popup menus.
- Several small compile-time bugs fixed.
- Under Win95, now uses RichEdit control instead of Edit control
  for wxMultiText and wxTextWindow, eliminating the memory limit.
  

Version 1.66E January 9th 1997
------------------------------

API CHANGES:

- Added WXDLLEXPORT symbols to core library, and notes in
  docs/dll.txt about a partially successful attempt to
  make a DLL out of wxWindows using VC++ 4.0.
- Added wxTextWindow::SetBackgroundColour, Motif only.
- Added copy constructor and assignment operator for wxTime.
- Added support for SQL_TIME, SQL_DATE, SQL_TIMESTAMP in database
  classes.
- Added makefile.g95 makefiles and other support for GNU-WIN32, B17;
  thanks Keith Garry Boyce!


BUG FIXES:

- Fixed bugs in wxListBox::Set and wxListBox::SetString, Windows.
- 'Fixed' bug in wxFont::RealizeResource, wxFillLogFont whereby
  changing from small to large font in Windows settings caused
  fonts to be garbage.
- Fixed bug in wxSleep, WIN32.
- Fixed quoting bug in wxEXTENDED style output in Dialog Editor.
- Fixed documentation for wxEXTENDED style (Motif and Windows).
- wxPanel under Windows should now receive character events in user
  edit mode.
- Added ISO character support, scaling, underline for wxPostScriptDC
  (contributions by Jens Claussen).
- Cured a memory leak in wxCommandProcessor::Submit, and another bug
  where the commands weren't being pruned if the current position was
  the start of the list.
- Changed wxButton::Create under X to work with XPM bitmaps.
- Added test at line 1091 of src/x/wx_panel.cpp to avoid XView crashes
  in some circumstances.
- Can now call wxDatabase::GetODBCVersionString/Float without having
  connected to a database.
- Added styles in MDI client window construction to give scrollbars
  when necessary.
- Added support for checkable menu items in .wxr files (4th item in spec).

Version 1.66D July 18th 1996
----------------------------

API CHANGES:


BUG FIXES:

- Fixed bug in wxCommandProcess::Submit that messed up
  Do/Undo ordering.
- Fixed bug in Motif wxCursor constructor.
- wxWindow::SetScrollPage sets WIN32 scrollbar thumb size.
- Fixed bug in wxGenericPrintDialog::DialogToValues ('to' page
  was set to 'from' value).
- Fixed wxCanvasDC::DrawRoundedRectangle under X (spurious
  lines where arcs 'missed') by adding fudge factors to
  arc angles.
- Under XView, frames and dialogs now always created with
  NULL parent since this makes wxFrameCloseInterpose get
  called.
- Fixed Motif wxComboBox bug in FindString

Version 1.66C June 25th 1996
----------------------------

API CHANGES:

- Added wxALIGN_LEFT/CENTRE/RIGHT style for wxMessage (Motif &
  Windows).
- Introduced wxVERSION_FLOAT symbol, which is 1.6603 for beta C of
  wxWindows 1.66.
- Added wxDatabase members GetInfo, GetODBCVersionFloat,
  GetODBCVersionString and modified ODBC sample to check for header/DLL
  version consistency.

BUG FIXES:

- Fixed another #ifdef WIN95 in msw/wx_win.cpp.
- Removed references to xbm files in resource sample; added
  menu resource example.
- Removed bug in Windows wxMultiText where return key didn't work.
- Removed Windows transparency bug in OnCtlColor, wx_win.cpp.
- Added IMPLEMENT_WXWIN_MAIN for samples and utilities (for the
  benefit of the AIX compiler).
- Menu resource loading fixed.
- Put all IMPLEMENT... macros into wb_data.cpp so dynamic libraries
  can be made under UNIX.
- Solved a problem associated with showing modal dialogs boxes
  and creating windows within the modal loop, under Windows.
- Debugged wxWindow::FindItem (internal Windows implementation
  function) which didn't take panel nesting into account.
- Debugged wxWnd::OnCtlColor (Windows) which caused a crash in
  wxScrollBar.
- Debugged Windows version of wxDC::DrawRoundedRectangle,
  where corner radii were being passed to RoundRect instead
  of diameters. May change the look of your rounded rectangles.
- Debugged MS VC++ 1.5 makefiles and source for compiling wxWindows
  applications as a DLL. Removed references to 'exit' in wx_mem.cpp.
- Fixed cleanup bug in ~wxbIPCObject.
- Fixed MDI-related bug under Windows that caused failure of MDI
  programs under NT (client_hwnd uninitialised).

Version 1.66B May 12th 1996
---------------------------

API CHANGES:

- Changes RX... variables in wxrefex.cpp to wxRX... in case of conflict
  with G++.
- Added maskbits argument to Motif wxCursor constructor.
- Added wxTab class library.

BUG FIXES:

- Added/fixed some Borland makefiles, incl. bombs, dialoged.
- Fixed a bug in wxMenuBar resource code; can now read panel resources.
- Added line in wxCommonCleanUp to clear the resource table, which
  eliminates a potential crash when bitmaps are used in resources.
- Corrected some syntax errors in wxEnhDialogBox, wxVirtListBox.
- Eliminated an overloaded wxMakeConstraintRange that caused ambiguity.
- Fixed DialogEd for Watcom (need wxString around some literals for some
  strange reason).
- Included wx.h in wx_bbar.cpp.
- Fixed UNIX dialog and frame style bug (&& -> &).
- Fixed #ifdef -> #if bug (WM_NOTIFY not recognised under non-Win95
  platforms).
- Fixed ntwxwin.mak so WIN95 needs changing in only one place.
- Fixed PrologIO compilation for Borland, Alpha, Ultrix.
- wxChart - DrawChart -> Draw in lbchart.h.
- Fixed Constdata problem for wxToolBar under UNIX.
- Fixed generic colour dialog bug.
- Changed 'delete this' to 'this->Close()' in wx_doc.cpp.
- Cured a menu deletion problem causing crashes on frame deletion under
  UNIX.
- Fixed some .b32 makefiles; changed name of Borland precompiled header
  file in dummy.cpp since .sym caused a tasm error.
- Fixed wxWin wxString implementation (wxstring.h/cpp) for Borland -
  #ifdefed out some operators that caused ambiguities, and altered
  some operator implementations that were causing infinite recursion.
- Tidied up contrib/ctl3d.
- Fixed property form crash on quitting window.
- #pragma'ed out wxstrgnu.h inline warning for Borland C++.
- Fixed wxPen, wxBrush under Windows so you can change the object's
  properties (if you first ensure the pen is selected out of DCs).
- Added stat/fstat patch from J-C Jorel for Linux/Motif2.0/ELF shared libraries.

Version 1.66 April 20th 1996
----------------------------

API CHANGES:

- Changed all C++ files to have extension cpp, with consequent
  changes to makefiles. Can be changed back (see 'mvfiles' in
  install directory).
- Added wxWindow::IsShown.
- Added new wxMessage constructors that take width and height (not
  effective in XView) and altered resource reading code to suit.
- Added wxWindow::SetSizeHints for Motif and Windows, to allow setting
  of minimum/maximum user sizing.
- Implemented wxButtonBar for Windows 95 (***NOTE***: API CHANGED, use
  CreateTools and AddSeparator functions).
- Improvements to wxToolBar including simple 3D button effect.
- Added wxSIZE_ALLOW_MINUS_ONE to use -1 as a valid window position.
- Changed return value of wxExecute, and added wxKill for UNIX.
- Added tentative wxComboBox for Motif and Windows. Combobox under
  Motif needs debugging.
- Added tentative wxRadioButton for Motif and Windows.
- Added wxWindow::Close to replace wxPostDelete: please use instead
  of 'delete window'. Delays deletion of window until application
  is 'idle', which can help with Motif memory problems in particular.
- wxMenu and wxMenuBar now inherit from wxWindow, not wxItem.
- Added extend and origin arguments for wxMetaFileDC, and changed
  behaviour of wxMakeMetaFilePlaceable (no longer adds extent and
  origin records). This should help generate better metafiles.
- Partitioned window flags into groups to allow for expansion, with
  2-letter naming convention. So wxPASSWORD becomes wxTE_PASSWORD.
  Backward compatibility is retained if styles are not stored
  as integers in files.
- Eliminated need within wxWindows for old type system using __type
  member and wxSubType function. Controlled by USE_OLD_TYPE_SYSTEM
  symbol in wx_setup.h.

BUG FIXES:

- Altered wxScrollBar::SetObjectLength behaviour under Windows
  to be consistent with Motif. Now SetViewLength must be called first.
- Fixed wxItem::Show under Windows - label was not being (un)shown.
- Fixed 'moving widgets' syndrome, where widgets were moveable
  by the user even in normal non-UI edit mode.
- Fixed wxScrollBar::Show under Motif.
- Added wxTextWindow::OnDropFiles support under Windows.
- Under X, improved pen colour allocation to find closest match
  if allocating a colour fails.
- wxMultipleChoice changed to wxGetMultipleChoice as per manual
  and header file.
- wxDC::GetTextForeground returned wrong value, corrected.
- Fixed memory bugs in samples/animate demo (shows up in Windows
  on exit).
- Fixed bug in wxBitmap constructor loading XPM files in XView
  (display variable not initialized).
- Added patch for wxCanvas::DoRefresh to cure Motif scroll error
  problems.
- Cured an XView seg fault bug in wxPanelRepaintProc by rewriting the
  the Rectlist -> XRectangle code. Problem appeared in wxHelp search
  dialog.
- Cured bug in wxMakeMetafilePlaceable for WIN32: wrong size header
  was written to the metafile.
- Updated all makefile.nt files for VC++ 4.0.
- Fixed Windows colour problem in wxSetClipboardData for wxCF_BITMAP;
  added wxCF_DIB support.
- Changed wxRadioBox::GetLabel to return static buffer, not newly
  allocated memory, to be consistent.
- Fixed Windows resource leakage problem by unsubclassing items in
  ~wxItem.
- wxButtonBar under WIN32 fixed (toggle buttons were not being displayed).
- wxColourDisplay bug fixed: in Windows, returned FALSE if number of
  colours was more than 256. Cures bug in wxPoem sample.
- wxPostScriptDC::DrawArc implemented; wxPostScript::DrawIcon
  implemented under X.
- wxBitmaps deleted on exit now (~wxGDIList changed to delete contents
  on all platforms).
- ~wxChoice under Motif fixed: deleting the choice menu explicitly caused
  crashes on some enviroments.
  
SAMPLES AND UTILITIES

- Added samples/resource example for .wxr usage.
- Added 'Bombs' sample (like Windows minefield game).
- Added wxweb, wximage utilities.
- Added wxHelp version 2: uses HTML. A couple of problems left
  to solve in wxHtml, but it's nearly there.
- Tex2RTF altered to output index files for wxHelp 2.
- wxGenericGrid fixed for Motif; can display bitmaps inc ells.
- More Dialog Editor fixes and enhancements.
- Sorry, wxBuilder files no longer compatible with earlier
  files because of changes to window styles.
- Added wxshlib directory to contrib: builds shared and static
  libraries for most versions of UNIX.

Version 1.65 December 1995
--------------------------

- Added wxChart library (directory utils/wxchart).
- Added Dialog Editor (directory utils/dialoged).
- Added wxProperty classes (directory utils/wxprop).
- Added Pressup game sample (directory samples/pressup).
- Some fixes and additions to Tex2RTF (see Tex2RTF manual).
- *NOTE* changed wxScrollBar prototype: 'direction' is now passed
  through the window style parameter.
- Filled in some missing wxTextWindow functionality
  under Windows.
- Added some wxText/wxMultiText functionality under Windows and Motif.
- Added Matthew's colour blitting for PostScript (X only).
- Added Matthew's font scheme (mandatory under X, optional under
  Windows).
- Added Matthew's changes to support multiple displays under X.
- Added font facename support under Windows.
- Added dynamic menu deletion code from Matthew: Motif, XView, Windows.
- Added wxItem::SetLabelFont, GetLabelFont for Windows.
- Added more Set/Get functions for wxGauge, wxSlider.
- Arguments to SetItem/Label/BackgroundColour now reference
  to wxColour instead of pointer. A copy of the wxColour is
  now stored, reducing memory management problems.
- Windows version of wxTextWindow::GetContents now returns
  new memory as documented (used to return wxBuffer).
- Fixed another memory bug in constraint system (added otherWin = NULL to
  ResetIfWin in wx_lay.cc).
- Fixed wxGroupBox::Set/GetLabel (Motif).
- Fixed wxRadioBox::SetLabel/ButtonFont (Windows).
- Fixed wxWindow::Refresh under X to clear background if requested.
- Removed an erroneous Motif dialog box widget destruction, which may
  be responsible for some dialog box crashes.
- Added contributed timeout code for IPC classes.
- Fixed wxTextWindow::GetLineText (Windows).
- Fixed wxPostScript::DrawText to cater for characters above 128.
- Fixed wxTextWindow delete key problem (Windows).
- 'Fixed' a Windows OnSize reentrancy problem when creating a large
  canvas (e.g. 1000x1000). Cause of OnSize reentrancy unknown, except
  that SetScrollRange appears to generate WM_ONSIZE.
- Untested wxFrame/wxDialogBox::OnChar/OnCharHook implementation for XView and
  Motif.
- Added wxDecToHex, wxHexToDec utility functions: used in resource system
  and Dialog Editor.
- Added wxDialogBox::SetModal.

Version 1.64 October 1995
-------------------------

- Eliminated more bad 'for' constructs in utilities.
- For MS Windows, instigated GDI resource-freeing scheme
  to help cut down on resource hogging by wxWindows apps.
  Any alterations to the wxWin code should take care not to
  defeat this scheme, which deletes GDI objects not currently
  being used.
- wx_bbar.cc: altered to use fewer bitmaps, and also to be
  WIN32-compatible with the proviso that toggle buttons
  don't work properly yet in WIN32.
- Added wxRecordSet::GetPrimaryKeys.
- Added wxWIN95 identifier for wxGetOsVersion. Is sensitive
  to OsVersion key in [wxWindows] section of win.ini: this can
  be set to fool wxWin into thinking it's running under a different OS.
  Otherwise, wxGetOsVersion should return the correct id.
- Now use WIN32 calls for wxFindFirstFile/wxFindNextFile.
- Fixed wxSetDirectory for NT.
- Fixed wxTextWindow::GetLineText for Motif.
- Added wxEntry function under Windows, to allow coexistance
  with other libraries, e.g. MFC.
- Added MFC example to show coexistance of wxWindows and MFC code.
- Added Set/GetExitOnFrameDelete (Windows).
- Added wxPoem to samples directory.
- Added monochrome blitting functionality for wxPostScriptDC.
- Added precompiled header scheme using wx_prec.h, which copes with
  most precompiled header schemes under Windows. You may need to
  change your source files accordingly if you assume that precompiled
  headers use wx.h.

Version 1.63 August 3rd 1995
----------------------------

- Better compatibility with GGC 2.7.0, w.r.t unused arguments (_some_
  warnings eliminated) and semantics of declarations with 'for' constructs.
- Changed wxRadioBox to take wxHORIZONTAL or wxVERTICAL style parameter:
  doesn't make sense to use the label positioning to determine layout
  style. ***This may break existing code*** so you may need to insert
  wxHORIZONTAL or wxVERTICAL into your radiobox style parameter.
- Fixed a bug in the wxTextWindow::OnChar interception code under
  Windows that caused sporadic GPFs on deleting/creating a text window.
  The text window wasn't being deleted from a list of handles.
- Added Stefan Hammes' wxString documentation and made the GNU wxString
  the wxWindows default for compilation purposes.
- Added classes: wxDate, wxTime, wxFraction, wxColourDialog,
  wxFontDialog. wxTime, wxFraction remain undocumented.
- Created wx/wb_cmdlg.h/cc files for common dialog classes and
  functions; moved some stuff out of wx/wb_dialg.h/cc into here.
- Added wxSetWorkingDirectory. *NB* drive-changing code needs to be
  added to this function for WIN32 platforms.
- Added wxGetLocalTime, wxGetCurrentTime to help wxTime class.
- Add unregistering of DDE name in ~wxServer (Windows platform). This prevents
  'invalid HWND' error messages from within DDEML when reinitialising
  the same server name.
- Cured a constraint system bug that left a dangling pointer: sometimes caused a
  crash on exiting print preview, for example. But there's *still* a bug
  left :-( as identified by Purify.
- Added Matthew Flatt's generic clipboard code to MS Windows platform
  (written in terms of existing clipboard functions).
- Improved Watcom makefiles, to use most wxWindows modules e.g.
  PrologIO, FAFA, etc. Makefiles now work for WIN16, WIN32 and WIN386
  Watcom targets.
- Worked around a Watcom WIN386 bug when using the CB_FINDSTRINGEXACT
  message: so now wxChoice::FindString works.

Version 1.62 (e) June 28 1995
------------------------------

- Fixed 'dangerous callbacks' in Motif, by checking for window id presence in
  hash table. This is because a window deletion may not prevent a
  callback from happening, and an invalid window may be used.
  This _should_ prevent some mysterious crashes.
- Rearranged wxFrame destructor code in Motif: I was deleting widgets in
  the wrong order (and therefore sometimes twice or more), which may
  also account for memory-related crashes.
- Fixed wrong dialog box positioning in Motif.
- Fixed Motif canvas scrolling for non-retained canvases.
- Fixed Windows icon-handling for frames: SetIcon should now work fine
  for all kinds of frame, and dragging shows the correct icon. Also
  introduced default icons in wx.rc which will be shown if none is
  suppled, e.g. canvas frame in hello demo.
- Added a few more icon and cursor-loading methods under Windows (see
  revised documentation).
- Simplified src/msw/wx_frame.cc.
- Fixed layout demo crash (wxRowColSizer::Create called itself).
- Fixed layout algorithm to accept width/height.AsIs() and
  also added wxDebugMsg warnings on constraint failure.
- Added install/install.inf for installing wxWindows using the
  wxWindows installer (utils/winstall). MS Windows only.

Version 1.62 (d) June 4th 1995
------------------------------

- Added and adapted Arthur Seaton's memory-checking code.
  It will be interesting to see how many platforms this actually
  works for. So, far VC++ 1.5, 16-bit Borland 4.0 and gcc-2.6.2
  on a Sun seem happy with it.
  See wxDebugContext and Debugging Overview, and wx_mem.h/wx_mem.cc.
- Added preliminary ODBC classes from Olaf Klein and Patrick Halke.
  See also samples/odbc.
- wxTextWindow now inherits from streambuf, except under
  BC++ (see comments in wb_text.h/cc).
- Changed make.env and UNIX makefiles to use OBJSUFF and SRCSUFF for
  compilers that need different object and source suffixes.
- Changed makefiles so DEBUG should now be an integer or undefined,
  and DEBUGFLAGS contains e.g. -ggdb which used to be set using DEBUG.
  All makefiles should now accept e.g. DEBUG=1 and pass this down
  the line.
- Removed many compiler warnings of the 'virtual member function
  hides...' form and checked for SunPro/Solaris compilation.
- Added samples/samples.txt, utils/utils.txt, contrib/contrib.txt.
- Added lots of DECLARE/IMPLEMENT_CLASS macros.
- Added contributed src/x/wx_ipc.cc fix.

Version 1.62 (c) May 28th 1995
-----------------------------

- Added wxFileHistory class, small changes to doc/view API.
- Started to overhaul documentation to be optimized
  for online help: will provide topic and class
  overviews wherever possible.
- wxbWindow, and therefore all window classes, now derive
  from wxEvtHandler. Added wxWindow::Set/EventGetHandler.
  All basic On... functions now in wxEvtHandler, so
  event behaviour becomes 'pluggable'.
- Promoted wxToolBar and wxButtonBar to the main wxWindows
  library and documentation, so I'm afraid you'll need to
  remove a few things from your application makefiles
  if you use these classes.
- Added double-clickability to XView listboxes (thanks
  to a hint from Alexander Mintskovsky).
- Added Matthew's experimental garbage collection patch.
- Added experimental macro IMPLEMENT_WXWIN_MAIN for
  AIX and other such naughty compilers that need
  main() to be defined in the application, not the
  library. Just in hello.cc and minimal.cc for now.

Version 1.62 (b) May 25th 1995 (not publicly released)
-----------------------------

- Added document/view/command architecture and sample.
- Lots of fixes to get it to compile under Solaris
  using Sun's compiler.
- Various AIX patches.
- Print/preview architecture starting to work(?) under
  UNIX using wxPostScriptDC, with simulated print and
  print setup dialogs. wxPrintSetupData added to tidy
  up the previously global print data.
- Contrib. code that broke wxText under Motif removed
  for now.
- Started wxSizer classes; unfinished and undocumented.

Version 1.62 (a) May 8th 1995
-----------------------------

- Added in Stefan Hammes' bug fixes and VMS patches.
  These include an alternative, GNU, wxString and wxRegex
  library.
- Added wxScreenDC (undocumented), wxGetActiveWindow under
  Windows.
- Added Matthew Flatt's X wxClipboard class; not yet
  documented or unified with the Windows functions.
- Added wxApp/wxWindow::OnCharHook hook function (Windows
  only). This means you can provide F1 and ESC functionality:
  wxMessageBox and a few others now respond to ESC.
- Added code in ~wxItem (under X) to remove the event handler
  from the item before deletion. This seems to cure a core
  dump I suddenly started getting when deleting a dialog box,
  where the event handler was called for a defunct item.

Version 1.61 (e) May 1995
-------------------------

- Changed return type of wxWindow::Show to Bool.
- Added wx_print.h, wx_print.cc to Windows code:
  a printing and previewing framework.
- Added printing sample (Windows only).
- Added wxUpdateIterator code, to be called within
  OnPaint to optimize repainting.

Version 1.61 (d) April 1995
---------------------------

- Added an argument to wxCanvas::SetScrollbars (porters beware!)
- Fixed a couple of files to work with MS C7.
- Added 'Classes by Category' section to the manual, long overdue.
- Added platform-independent window layout facility (wx_lay.h/cc)
  See documentation and new 'layout' sample.
- Fixed Motif canvas (and by inheritance, panel) behaviour
  so should be _fixed_ size unless explicitly resized.
- Dialog style wxMOTIF_RESIZE always implied now. This may
  mess up Motif 1.1 systems but causes much less confusion
  for 1.2 and above. It's a nasty resizing issue.
- Added fixes for wxCanvas::OnSet/KillFocus under X.

Version 1.61 (c) March 1995
---------------------------

- wxPanel and wxDialogBox are now more or
  less fully-functional subclasses of wxCanvas for
  Motif, XView and Windows. Added wxPanel::GetPanelDC().
- Added simple 'panel' sample to show above feature.
- Added contributed static items (separators etc.):
  still some work to do here to get them going properly
  and documented. See samples/static.
- New OnPaint(wxRectangle *rects, int n); needs some
  work.
- Contributed virtual listbox added, needs documenting
  and the 'vlist' sample seems to crash.
- Contributed wxScrollBar item added (undocumented).
- wxCanvas::OnScroll member defined for Motif, XView
  and Windows. Override to redefine scroll behaviour.
  Needs some testing. See documentation.
- Motif version of wxDialogBox: removed unnecessary
  Bulletinboard widget; please define X resource for
  "dialogBox" for a reasonable dialog box colour.
- Added facilities for editing panels and dialog
  boxes, by calling wxPanel::SetUserEditMode.
  Almost working, just the odd glitch.
  Use this for building your own IDE!
- Started to rewrite wxBuilder to use the above
  facility instead of the simulation window.
- New embedded language helper library called
  wxExtend created: used for wxCLIPS and wxPython.
  Distributed separately.
- For UNIX, separated out main.c and wx_main.cc.
- Corrected an editing bug in wxTextWindow under Windows,
  added wxTextWindow::OnChar for Motif: XView will
  probably be impossible.
- Rationalised files: X and Windows versions of wx_item.cc
  separated into individual files (wx_buttn.cc etc.)
- Eliminated some unnecessary header files for Windows
  compilation, hopefully speeding up non-VC++ compilation
- Converted wxXPM argument syntax to ANSI to eliminate warnings
- Updated documentation -- there were many missing functions and
  styles.

Version 1.61 (a-b) January 1995
-------------------------------

- *** MAJOR CHANGE ***
  Text windows and canvases can now be children of panels,
  in Windows (only). So the parents of these subwindows
  are now wxWindow instead of wxFrame.
- *** MAJOR CHANGE ***
  wxPanel is a subclass of wxCanvas in Windows (only), so
  that you can draw on panels (or put buttons on canvases).
  This is in line with the wxWindows policy of augmenting the
  lowest-common-denominator approach with platform-specific extensions.
- *** EVEN MAJORER CHANGE ***
  wxWindows resource system added (coded mostly in in wb_res.cc).
  Requires PrologIO to compile. wxBuilder now supports it.
- Header files sorted out (e.g. wb_gdi.h): weren't
  including all the right files.
- Borland makefile fixed.
- Other bad makefiles fixed.
- Most 'virtual function hiding' warnings eliminated
- Added wxFindFirstFile, wxFindNextFile support for Borland.
- Added wxGroupBox panel item for Windows and Motif.
- Added wxGauge panel item for Windows.
- Added wxMessage bitmap support for Windows, Motif and XView
- CaptureMouse and ReleaseMouse were broken in Windows
  because of Leave/Enter notification fix; should be OK now.
- X colour bug fixed (colour worked on Suns but not on other
  X terminals).
- Fixed PostScript dialog bug (preview/print the wrong way around)
- Added Motif gauge support using Bull's gauge add-on (see
  contrib/xmgauge).
- Added XView gauge support
- wxMessageBox now uses notices under XView (optionally)
- Borland makefiles replaced and renamed borland.mak (some alternative
  Borland makefiles are in contrib in the distribution)
- XPM and wxXPM now bundled with the main distribution and
  integrated properly into wxBitmap (see documentation).
  This allows use (for example) of colour buttons under X
  (and optionally, under Windows using XPMs).
- XPMShow utility (utils/xpmshow) converts BMP<->XPM under Windows.
- VC++ makefiles now changed to add all optional libraries
  (e.g. ctl3dv2.lib, fafa.lib, gauge.lib) to wx.lib, so
  if the wxWindows configuration is changed, only
  wx_setup.h and src\msw\makefile.dos need to be altered,
  and not each application makefile.
  *** NOT DONE *** for other makefiles yet!
- New wxButtonBar library: same as wxToolBar, but under Windows
  the behaviour is nicer (3D, depressable buttons).
- MDI toolbar now possible by using wxFrame::SetToolBar (see
  manual)

Version 1.60 October 1994
-------------------------

- Numbering scheme changed: `beta' is an inappropriate term now,
  and the numbers will now go 1.60, 1.61 etc.
- Major changes to UNIX makefiles to centralize settings in
  src/make.env.
- Reduced the number of files included by some of the wxWindows
  sources, and compilation speed is now optimal for both (precompiled)
  Visual C++ and (non-precompiled) UNIX, without the need to
  change source code.
- Improved installation script.
- Added in the contributed Symantec and Borland makefiles.
- Addition of FAQ list
- Improvements to wxTextWindow (see Class Reference) but still
  no interception of input I'm afraid. Optional editable Windows
  text window; Copy/Cut/Paste in Motif and Windows.
- Debugged wxCanvas character input.
- Fixed a bad Motif modal dialog box bug (symptom was
  non-return from the modal loop). Various other Motif bugs
  fixed.
- Added more file-handling utilities (see wx_utils.h and
  documentation of miscellaneous functions).
- Fixed bug in X code where wxColour objects could multiply
  ad infinitum: wxColours are no longer left around for reuse.
- Added wxBegin/EndBusyCursor for long waits, including
  popping up standard dialogs
- Fixed wx_setup.h bugs so disabling components really works...
- Just enough wxColourMap support to enable bitmaps loaded
  with 'dib' or 'wxImage' libraries to be displayed ok.
- DrawRoundedRectangle now accepts negative corner radius
  values to denote a size proportional to the rectangle.
- XView listbox and text item sizing was wrong. Motif slider sizing
  was also wrong.
- Problem with Motif popup menus noted, but not fixed: doesn't
  show up in demo, for some reason. 'FakePopupMenu' provided
  in case it shows up.
- Added many patches from contributors, including:
    - Improved X colours, plus a colour sample in utils/colours
    - wxTextWindow editable under Windows if using wxNATIVE_IMPL flag
    - wxMultipleChoice convenience dialog
    - wxExecute now uses fork under UNIX, and has two forms
    - wxShell
    - Some PostScript output optimisation
    - 3D animation demo
    - Under MWM, Motif dialog and frame styles take effect. At last!
    - Improved PostScript printer dialog
- Added various styles to panel items, e.g. wxHSCROLL in wxMultiText.
- Added optional support under Windows for ItsyBitsy (small) title bars.
  Also included CTL3DV2 which seems more reliable than version 1.
- wxDC::GetSize can now be used to achieve proper output on a
  wxPrinterDC
- Better support for GCC and Linux, specifically addition of #pragmas
  to cut down binary size.
- Additional utilities: improved Windows DIB BMP display code,
  wxImage UNIX GIF/BMP/XBM loading/displaying, and mfutils: a modest
  start at reading Windows metafiles in a platfrom-independent way.
- wxBuilder can display bitmaps in canvases; various bugs fixed, Motif
  version functional (except for refresh problems).
- Allow passing NULL to wxDC::SetPen, SetFont, SetBrush, SetColourMap,
  SelectObject so that GDI objects can be selected out of the DC,
  allowing them to be deleted by the programmer before the DC is
  destroyed. The Colour Sampler is an example of a program that needs
  this.
- Added wxSlider support to wxBuilder.
- Windows version of wxText can now optionally intercept the
  wxEVENT_TYPE_TEXT_ENTER_COMMAND events if the wxText
  is created with the wxPROCESS_ENTER style (see hello.cc)
- VMS support added (though untested since 1.50).
- wxTextWindow OnChar maybe intercepted under Windows (untested).

Version 1.50 beta (k) patch (3)
-------------------------------

- Changed parent argument of wxDialogBox constructor to
  be wxWindow so a dialog box can be a child of a frame
  or dialog box. Should have no effect on people's
  existing code (isn't C++ nice sometimes!)

Version 1.50 beta (k) patch (2)
-------------------------------

- Environment variable WX replaced by WXWIN to avoid
  clash with MS C++ wx utility.
- Support for Visual C++ in makefiles.
- Better support for wxBuilder, both in utils\wxbuild and
  wxWindows library (e.g. wxWindow::Refresh(), ScreenToClient/ClientToScreen)
- Some IPC bugs fixed
- Windows cursors supplied (omitted from beta (k) UNIX distribution)
- Motif wxListBox out-by-one error fixed
- Some Tex2RTF improvements (see WinHelp manual)
- Partial fix for bug under Windows, where the wrong window gets
  highlighted after a window is destroyed (particularly when
  a modal dialog has been used previously). This patch (raising the
  parent or main window) is in src\msw\wx_win.cc, wxWnd::DestroyWindow.
  Perhaps it should be moved into wxFrame/wxDialog::Show() since a
  flicker effect is noticable.
- Problem with transparent brushes under Windows sorted.

Version 1.50 beta (k) May 1994
------------------------------

- *** PLEASE note important memory allocation changes in notes for (j) ***
- Numerous memory leak bug fixes, and cures to other sillinesses.
  Thanks largely to Patrick, most platforms far more stable: major
  WIN32s and NT problems fixed.
- Some changes to be more Borland-compatible. Are we there yet?!
- Fixes to FAFA, previous version had serious cross-process bug.
- MDI focus problem 'fixed' by calling OnActivate when
  Show(TRUE) is called.
- Some code generation bugs fixed in wxBuilder. Yes, I'll do a UNIX
  version soon...
- New bits and pieces:
  * dynamic menu Append/SetLabel
  * mouse enter/exit code
  * accelerators (Windows only)
  * efficiency measures
- New sample: Andrew Davison's fractal mountain generator.
- Tex2RTF: cooperates with Word for Windows 6.0 fields; tables are
  better; more configurable; HTML WinHelp-like buttons added.
- Directory structure on ftp site reorganized a bit; beta
  directory removed.

Version 1.50 beta (j) April 1994
--------------------------------

- IMPORTANT -- memory allocation. (Nearly) all functions that
  return strings now return a pointer to static memory.
  Calling functions should copy this data for long-term
  use. If you currently free memory returned from
  the following functions, you must change your code.
  Also, because the same buffer may be used
  for two consecutive calls, you may see 'wrong' values
  being returned if you do not copy the return value.

  FloatToString
  DoubleToString
  IntToString
  LongToString
  FileNameFromPath
  PathOnly
  wxFileSelector
  wxButton::GetLabel
  wxMenu::GetLabel
  wxChoice::GetLabel
  wxListBox::GetLabel
  wxRadioBox::GetLabel
  wxText::GetLabel
  wxText::GetValue
  wxMultiText::GetLabel
  wxSlider::GetLabel

- IMPORTANT - wxMessageBox change.
  The final (centring) parameter has been removed; wxCENTRE may now
  be specified in the style parameter (the default). Under Windows,
  the native MessageBox function is now used _unless_ wxCENTRE
  is specified, in which case the generic function is used
  (MessageBox can't centre text). Calls to wxMessageBox
  that didn't specify the style should behave as before.

- Addition of wxBuilder. Tan-tan-tarrah!!
- Installation script for UNIX (install/wxinstal).
- GNU wildcard matching code replaced with non-GNU code
- Non-Xfig spline code option (slower than the Xfig version)
- wx_setup.h added for configuring wxWindows compilation
- wxString class added (very simple, really implemented for
  the purposes of translating CLIPS to C++.)
- wxCLIPS removed from wxWindows distribution; available
  separately along with CLIPS2C translator.
- Some major bugs in MDI implementation removed, specifically
  the problem with maximizing a child, then closing application.
- Various Motif problems solved, including: tiny buttons (solved
  by unmanaging buttons when setting the default button);
  panels refusing to resize or move properly (solved by specifying
  panel to be resizeable, and also unmanaging panel before moving);
  hash table entries weren't being deleted properly.
- Improvements to Tex2RTF (see relevant documentation).
- First stab at a 'Resource Guide' in manual, documenting wxWindows
  contributions.
- Daft logo added to wxWindows manual.

Version 1.50 beta (i) December 1993
-----------------------------------

- wxPanel::SetButtonFont and wxPanel::SetLabelFont
  control fonts in panels (Motif and Windows only).
- Panel-in-panel support improved, but still doesn't
  work for wxABSOLUTE_POSITIONING in Motif.
- User-contributed Fafa library implements bitmap buttons
  in Windows (some incompatibility with CTL3D).
- 2-D wxRadioBox supported; individual radio buttons may be
  grayed out.
- Option to compile most Motif panel items using gadgets
  (can be more efficient).
- wxListBox can be created with or without scrollbars (Motif).
- wxGraphLayout and wxTreeLayout classes added to utils.
- Windows and X resource reading and writing functions added.
  See wxGetResource, wxWriteResource.
- Compiles without error using HP C++ and Motif 1.2.0
  (lots of warnings though): hp target added to makefiles.
- Some bugs removed from Tex2RTF, and now yields to
  Windows in a more reasonable fashion. Bitmap inclusion and
  bullet support improved.
- User-contributed WINSOCK support (contrib directory of ftp
  site).
- XView wxPanel::GetPosition bug removed, so wxPanel::Fit() works better.

Version 1.50 beta (h) November 1993
-----------------------------------

- FINALLY got wxWindows working with Motif 1.2.1. Involved
  doing my own panel item positioning (like Windows 3.1 code)
  and more or less abandoning constraints: use
  wxASBOLUTE_POSITIONING if you want to mix relative/absolute
  positioning. Also canvas creation now has right sequence of
  XtRealizeWidget and XtManageChild, which fixes the X error.
- Reorganized LaTeX converters into one, called Tex2RTF, in
  utils/tex2rtf.
  Parses more syntax and now outputs linear RTF, WinHelp RTF,
  XLP (wxHelp), and HTML (World Wide Web/Mosaic format).
- Help files reorganized so each manual is in one file.
- wxHelpInstance now has optional argument so an app can use
  wxHelp under X, Windows Help under Windows 3.1.
- Basic Windows 3.1 colours handled, by changing RGB definitions.
- Binary files (BMP, HLP, ICO) should be ok in distribution now.
- Improved Windows NT compatibility.
- Hello demo shows off multiple status line regions (slightly
  broken in Motif, doesn't show as separate regions)
- Microsoft CTL3D support added (a compiler switch on making
  library).
- Debugged default wxFrame::OnActivate so doesn't set the focus
  for inappropriate windows.
- DrawPolygon now closes polygon automatically on all platforms.
- DrawArc implemented for Windows and XView, not PostScript. Not tested.
- Partial panel-in-panel support added for Motif and Windows -- not tested!
- SetScrollbars has 2 extra args for scrolling to a position.

Version 1.50 betas (a)-(g) September 1993
-----------------------------------------

- Added argument to convenience dialogs to specify whether the
  message should be centred, and allowed newlines in message.
- Fixed bug in wxDC::Clear which didn't clear all of the
  canvas if it had been scrolled.
- Added utils/wxclips for interfacing CLIPS with wxWindows
  (needs modified CLIPS 5.1 source)
- Fixed DrawRoundedRectangle under X. Scaling a rounded rectangle
  led to rounding (!) errors, manifested by streaks on a colour
  display.
- Added ::wxGetFreeMemory, ::wxGetTempFileName, ::wxGetHostName, ::wxGetUserId,
  ::wxGetUserName functions
- Reduced size of status line.
- Added utils/toolbar - see documentation in utils/toolbar/docs.
- Various fixes to Motif
- Some Windows-specific frame styles, e.g. wxSTAY_ON_TOP
- Restructured files to separate base from platform-specific functionality
- separated out device contexts (wxDC is now virtual, parent of wxCanvasDC,
  wxPostScriptDC, wxMetaFileDC, wxPrinterDC)
- Improved bitmap handling, now uses XBM files under X
- Added wxRadioBox
- Added drag and drop to Windows platform
- Added help strings to menus, and default OnMenuSelect handler in wxFrame
  which displays the strings on the status line (not XView)
- Added PROLOGIO to distribution, removed object library and demo (sorry!)
- Added docs target to makefiles, for latexing and generating help files.
- Fixed scrollbars so resizing resets the range and position of scrollbar.
- Solved the colour problem (RGB values given to XAllocColor were too small).
- Fixed PostScript colour bug (RGB values too BIG this time!)
- Fixed bug with XView frame closing; caused segmentation fault, Notifier errors
  -- still a problem with dialog box closing from WM
- Added NT fixes.
- Added Linux and System V patches.
- Added multi-field status line
- Updated the documentation and converted to Windows help format
  (Latex->RTF utilities included). There are now lots of references
  (jumps) in the documentation, and a Rough Guide section in class ref.
- All widget contructors now have optional style and name parameters

Version 1.40 April 1993
-----------------------

- First Motif version. Requires Motif 1.1.
- UNIX makefiles changed; all have 'motif' and 'xview' targets, plus
  GUI variable (e.g. GUI=-Dwx_xview).
- wxText::GetValue and wxMultiText::GetValue now return strings
  allocated with new, as opposed to a static buffer. Delete these or
  your programs will have memory leaks! Sorry about the change.

Version 1.30 April 1993
-----------------------

- Windows 3.1 wxTextWindow scrolling fixed: adding text didn't work properly.
  Now scrolls without flashing.
- Windows 3.1 wxCanvas scrolling actually scrolls the canvas, avoiding the
  need for clearing the screen first. This results in scrolling
  appearing smoother.
- Windows 3.1 wxMultiText::GetValue now works. Setting a wxMultiText item
  works only if the text has carriage return, linefeed at the end of each
  line.  XView wxMultiText also fixed so setting the size works.
- wxPanel::SetLabelPosition now works in Windows 3.1 for wxChoice, wxListBox
  and wx(Multi)Text. All other items have no or horizontal label only.
- Added wxHelp hypertext help application and wx.xlp for on-line wxWindows
  class library documentation. API for invoking wxHelp is in wx_help.h.
  Includes hypertext library and tools for converting Latex files to xlp files.
- Added wxWindow::GetGrandParent.
- Added wxWindow::SetFocus, wxWindow::OnSetFocus, wxWindow::OnKillFocus.
- Added wxItem::SetDefault,
- Used SetFocus and SetDefault in convenience dialogs.
- Added wxWindow::OnActivate (called under Windows only).
  Default behaviour of wxFrame::OnActivate is to set focus for first child.
- wxMessageBox improved to handle large messages containing new line characters.
- Bug fix for wxCanvas constructor.
- Added AddEnvList to wxPathList class, e.g. AddEnvList("PATH") adds path
  directories to path list.
- Included some tips from a Borland user in contrib directory.
- First stab at WIN32 (NT) compatibility (not tested).

Version 1.20 February 1993
--------------------------

- removed the need for using Microsoft C/C++, so Borland
  and other compilers should work
- destructor order dependencies removed
- added limited support for bitmaps and icon drawing (see hello.cc)
- added Centre/Center members for panel items, dialogs and frames
- added OnActivate member for MDI frames
- GDI objects (fonts, pens etc.) now clean themselves up on exit
- GDI object lists now allocated dynamically so Sun dynamic libraries
  can be built
- DOS makefile improved for DLL support
- sizing bug in wxMultiText fixed
- Windows & and \t menu control characters are stripped out under XView
- MDI Window menu is inserted before Help if it exists
- MDI main windows can now have a status line
- debugged pull-right menu support
- added object graphics library and demo

Version 1.01 January 1993
-------------------------

First official release.

- added EPS to both DOS and UNIX versions
- added minimal metafile support under Windows
- added filter to the file dialog
- some bug fixes

Version 1.00 November 1992
--------------------------

First preliminary release.
